<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as CallToAction,
  Copy,
  Table as SlpTable,
} from '../components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  components: {
    SlpTable,
    CallToAction,
    Copy,
  },
  nuxtI18n: false,
  async asyncData() {
    try {
      const res = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'terms',
      });

      const { pageContent } = res.items[0].fields;
      const metadataRes = res.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: metadataRes.ogTitle,
        description: metadataRes.description,
        og_title: metadataRes.ogTitle,
        og_description: metadataRes.ogDescription,
      };

      const data = {
        hero: {
          title: pageContent[0].fields.header,
          subtitle: pageContent[0].fields.text,
          horizontal_rule: true,
          centered_by_default: true,
        },
        copy: {
          block: [
            {
              text: pageContent[1].fields.text,
              hide_horizontal_rule: true,
            },
          ],
        },
        tables: [
          {
            title: pageContent[2].fields.header,
            table: pageContent[2].fields.text,
            tableIsMarkdown: true,
          },
          {
            title: pageContent[3].fields.header,
            table: pageContent[3].fields.text,
            tableIsMarkdown: true,
          },
        ],
      };

      return { data, metadata };
    } catch (error) {
      throw new Error(error);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
});
</script>

<template>
  <SlpContainer>
    <CallToAction :data="data.hero" />
    <Copy :data="data.copy" />
    <section v-for="table in data.tables" :key="table.title">
      <SlpTable :data="table" />
    </section>
  </SlpContainer>
</template>

<style>
/* Custom styles for this page only */
hr.slp-hr {
  margin-bottom: 0 !important;
}

.container {
  margin-bottom: 24px;
  width: 80%;
  margin-left: auto !important;
  margin-right: auto !important;
}
</style>
